#include <vector>
using namespace std;

#define MOUSE_NOP		0
#define MOUSE_LEFT		1
#define MOUSE_MIDDLE	2
#define MOUSE_RIGHT		3

#define TYPE_LABEL		1
#define TYPE_BUTTON		2
#define TYPE_TEXT		3

struct _iPoint2D
{
int x;
int y;
};

class _Objet
{
public:
	_iPoint2D Position;
	_iPoint2D Taille;
	char Caption[30];
	char Name[30];
	bool Active;
	int Type;
	bool ClicOn;

	bool Focus;

	void (*OnClick)();
	bool UseOnClick;

};

class _windows
{
public:

	vector<_Objet>Objet;
	int NDObjet;

	void _windows::AddObjet(char *Caption,char *Name,_iPoint2D Pos,_iPoint2D Tail,int type,void(*OnClick)());

	_iPoint2D Position;
	_iPoint2D Taille;
	char Caption[30];
	char Name[30];

	bool bQuit;
	bool bRed;

	bool Active;

	int Place;

	float Blend;
	bool Reduit;

	void _windows::DrawObjet();

	/*
	int etat;
	int dep;
	int place;
	int flag_quitter;
	int flag_reduction;*/
};

class _HUD
{
private:

vector<_windows>Windows;
int NDWindows;

int WindowsX;
int WindowsY;

int Mouse;
_iPoint2D MousePos;
_iPoint2D MousePosFC;

GLuint TextureA[2];

int WinMove;
int _HUD::ClickBorder(int x,int y);
void _HUD::SetFocusWindows(int Win);
int _HUD::ClickWindows(int x,int y);
int _HUD::ClickClose(int x,int y);
int _HUD::ClickRed(int x,int y);

_Objet *pObjetDeclick;
bool UseObjetDeclick;

_Objet *pObjetFocus;
bool UseObjetFocus;

bool Font;

public:
void _HUD::Inis(char *BMP,bool Fond);
void _HUD::Draw();
void _HUD::AddWindows(char *Caption,char *Name,_iPoint2D Pos,_iPoint2D Tail,bool CloseB,bool RedB,float Blend);
//void _HUD::AddObjetToWindows(char *wName,char *Caption,char *Name,_iPoint2D Pos,_iPoint2D Tail,int type,void (*OnClickF)());
void _HUD::AddObjetToWindows(char *wName,char *Caption,char *Name,_iPoint2D Pos,_iPoint2D Tail,int type,void(*OnClick)());
void _HUD::Key(unsigned char key);


void _HUD::SetHUDSize(float x,float y);
void _HUD::MouseMove(float x,float y);
void _HUD::MouseClick(int button,int state,int x,int y);
void _HUD::SetObjetCaption(char* Win,char* Objet,char* Caption);
void _HUD::SetWindowsCaption(char* Win,char* Caption);
void _HUD::KillWindow(char* Win);
void _HUD::ReduceWindow(char* Win);
void _HUD::ExpendWindow(char* Win);
void _HUD::SetWindowPos(char* Win,int x, int y);
void _HUD::SetWindowBlend(char* Win,float Blend);
int _HUD::ObjetInWindows(int win,int x,int y);
void _HUD::GetObjetCaption(char* Win,char* Objet,char* Caption);
void _HUD::DesactiveAllFocus();

};

_iPoint2D Point2D(float x,float y);
