#include <gl\glut.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "guigl.h"

_HUD HUD;

void Draw()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	HUD.Draw();
	glutPostRedisplay();
	glutSwapBuffers();
}

void Key(unsigned char key,int x,int y)
{
HUD.Key(key);

}

void Mouse(int x,int y)
{
HUD.MouseMove(x,y);
char tText[30];
sprintf(tText,"Position : %i %i",x,y);
HUD.SetObjetCaption("Win1","Label1",tText);
}

void MouseClick(int button,int state,int x,int y)
{
HUD.MouseClick(button,state,x,y);
}

void Reshape(int width, int height)
{
	HUD.SetHUDSize(width,height);
	glViewport(0,0,width,height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0,width,0,height,1,-1);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void ClickButton()
{
HUD.SetObjetCaption("Win2","Label1","Click 1");
}
void ClickButton2()
{
HUD.SetObjetCaption("Win2","Label1","Click 2");
}
void ClickButton3()
{
HUD.AddWindows("FenetreRND","WinRND",Point2D(rand()%200+100,rand()%200+100),Point2D(150,100),true,true,1.0f);
}
void ClickButton4()
{
HUD.KillWindow("WinRND");
}
void ClickButton5()
{
char tText[255];
HUD.GetObjetCaption("Win1","Text1",tText);
HUD.SetObjetCaption("Win2","Label1",tText);
}

int main()
{

	HUD.Inis("hui.bmp",true);
	HUD.AddWindows("Fenetre1","Win1",Point2D(100,100),Point2D(300,200),false,true,1.0f);
	HUD.AddWindows("Fenetre2","Win2",Point2D(300,280),Point2D(150,100),true,true,1.0f);

	HUD.AddObjetToWindows("Win1","Label","Label1",Point2D(50,100),Point2D(50,20),TYPE_LABEL,NULL);
	HUD.AddObjetToWindows("Win1","Boutton 1","Button1",Point2D(50,50),Point2D(60,20),TYPE_BUTTON,ClickButton);
	HUD.AddObjetToWindows("Win1","Boutton 2","Button2",Point2D(150,50),Point2D(60,20),TYPE_BUTTON,ClickButton2);
	HUD.AddObjetToWindows("Win1","Cree Fenetre","Button3",Point2D(50,20),Point2D(80,20),TYPE_BUTTON,ClickButton3);
	HUD.AddObjetToWindows("Win1","Tuee Fenetre","Button4",Point2D(150,20),Point2D(80,20),TYPE_BUTTON,ClickButton4);
	HUD.AddObjetToWindows("Win1","Text1","Text1",Point2D(50,130),Point2D(80,20),TYPE_TEXT,ClickButton5);
	HUD.AddObjetToWindows("Win1","OK","Button5",Point2D(150,130),Point2D(30,20),TYPE_BUTTON,ClickButton5);

	HUD.AddObjetToWindows("Win2","Bonjour","Label1",Point2D(20,20),Point2D(50,20),TYPE_LABEL,NULL);

	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutInitWindowSize(500,400);
	glutCreateWindow("Windows");
	glutDisplayFunc(Draw);

	
	glutReshapeFunc(Reshape);

	glutKeyboardFunc(Key);
	glutMotionFunc(Mouse);
	glutMouseFunc(MouseClick);
	glutMainLoop();
	return 0;
}